      Program FREQASPJ


      IMPLICIT REAL*8(A-H,O-Z)
      LOGICAL CORDON, STADON
      character*70 infile
      character*3  outfile
      character*70 outputfile
      
      PARAMETER (MAXOBS=10000)
      PARAMETER (MAXF=400001)
      PARAMETER (MAXD=400000)
      PARAMETER (INP=9,IOUT=10)
      
      DIMENSION T(MAXOBS),X(MAXOBS)
      DIMENSION F1(MAXF),S1(MAXF)
      DIMENSION W1(MAXD),W2(MAXD),W3(MAXD),W4(MAXD)
      real*8    winfout,tijdfout,fotfout,tijdspanne,piektopiek
      real*8    sigma

      INTEGER   isoort

  2   FORMAT(1X,A78)
      n_files = 0
   
C     INGEVEN VAN DE WAARNEMINGEN

  5   write (6, *) 
     &    'Give the name of the file with the data (eof for end)'


      read(5,*) infile
      If(infile.eq."eof") goto 999

      OPEN (INP,FILE=infile,STATUS='OLD')
      CALL DLEES(INP,MAXOBS,N,T,X,isoort,winfout,tijdfout,fotfout,
     v     tijdspanne,piektopiek)
      IF (N.LE.0) STOP 'N<=0'
      CORDON=.FALSE.
      STADON=.FALSE.
      

      CALL DOBSTA(N,T,X,XGEM,XVAR,0,sigma)

 10   CONTINUE
      WRITE(6,*)  
      WRITE(6,*) 'Methode:  1 = Jurkevich-Stellingwerf, 2 = Scargle'
      WRITE(6,*) '          0 = statistics,             3 = END'
      READ(5,*)   IMETH
      IF (IMETH.EQ.3) GOTO 5
      IF ((IMETH.LT.0).OR.(IMETH.GT.3)) GOTO 10      
      IF (IMETH.EQ.0) THEN
        CALL DOBSTA(N,T,X,XGEM,XVAR,6,sigma)
        STADON=.TRUE.
        GOTO 10
      ENDIF  

c     @@@@@@@@@@@@@@ Peter-ke @@@@@@@@@@@
      write(6,*)
      write(6,*) 'Give the desired name of the outputfile'
      read(5,*)  outputfile
      write(6,*)
c     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@      

      IF (.NOT.CORDON) THEN 
        IF (.NOT.STADON) THEN
          CALL DOBSTA(N,T,X,XGEM,XVAR,0,sigma)
          STADON=.TRUE.
        ENDIF        
      
C       NULPUNTSCORRECTIE VOOR DE TIJD

        T0=T(1)
        CALL DOBSCO(N,T,T0)
        T(1)=0.

C       WAARNEMINGEN NAAR GEMIDDELDE NUL BRENGEN
      
        CALL DOBSCO(N,X,XGEM)
        XX=(N-1)*XVAR
        CORDON=.TRUE.
      ENDIF 
       
 20   WRITE(6,*) 'Frequentiestap (0=back)'
      READ(5,*) DF

      WRITE(6,*) 'Startfrequentie, eindfrequentie (0,0=back)'
      READ(5,*) F0,FN
      IF ((F0.EQ.0.).AND.(FN.EQ.0)) GOTO 10
      
      NF=IDINT((FN-F0)/DF+0.001)+1
      WRITE(6,*) 'Startfrequentie = ',F0
      WRITE(6,*) 'Eindfrequentie  = ',FN
      WRITE(6,*) 'Frequentiestap  = ',DF
      WRITE(6,*) 'Aantal stappen  = ',NF
      IF (NF.LT.1)    STOP 'NF<1'
      IF (NF.GT.MAXF) STOP 'NF>MAXF'
      IF (IMETH.EQ.2) THEN 
        WRITE(6,*) 'SCARGLE 2'        
        CALL SCAR2(N,X,T,F0,NF,DF,F1,S1,W1,W2,W3,W4)
        FACT=SQRT(4.D0/DBLE(N))
        peak_value = 0
        
        DO  K=1,NF
          S1(K)=FACT*SQRT(S1(K))
          if (S1(K).gt.peak_value) then
              peak_value     = S1(K)
              peak_frequency = F1(K)
          end if
        end do 
        period = 1./peak_frequency 
        WRITE(6,80) peak_value, peak_frequency, period
  80    format(1x,'Maximum: ',G15.9,' at frequency: ',G15.9,
     &         ' P = ',G15.9)

      ELSE
        WRITE(6,*) 'JURKEVICH-STELLINGWERF' 
        WRITE(6,*) 'Aantal bins,aantal covers (1<NB*NC<50)'
        READ(5,*) NB,NC
        CALL JUSTEL(N,X,T,F0,NF,DF,NB,NC,XVAR,XX,F1,S1) 
        peak_value = 9.D09
        DO  K=1,NF
          if (S1(K).lt.peak_value) then
              peak_value     = S1(K)
              peak_frequency = F1(K)
          end if
        end do
        period = 1./peak_frequency 
        WRITE(6,85) peak_value, peak_frequency, period
  85    format(1x,'Minimum: ',G15.9,' at frequency: ',G15.9,
     &         ' P = ',G15.9)
      ENDIF

      n_files = n_files+1
      write(outfile,88)  n_files
  88  format (I3.3)
      OPEN (Iout,FILE=outputfile)

      
 90   CALL TESTOU(IOUT,NF,F1,S1)
      close (iout)

      GOTO 10
        
 999  CONTINUE
      STOP
      END

      SUBROUTINE TESTOU(IOUT,NF,F1,S1)

C     UITSCHRIJVEN VAN DE TESTSTATISTIEK OP UNIT IOUT

      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION F1(NF),S1(NF)

      DO 1100 K=1,NF
         WRITE(IOUT,1101) F1(K),S1(K)
1100     CONTINUE
1101  FORMAT(1X,F20.8,1x,F20.8)

      RETURN
      END
      
c-------------------------------------------------------------------------------
      SUBROUTINE DLEES(INP,MAXOBS,N,T,X,isoort,winfout,tijdfout,fotfout,
     v     tijdspanne,piektopiek)
 
      IMPLICIT  REAL*8(A-H,O-Z)
      parameter (tpi=6.2831853071795865D0)
      DIMENSION T(MAXOBS),X(MAXOBS)
      real*8    xmin,tijdspanne
      real*8    tijdfout, fotfout, winfout, rN,piektopiek
      integer   i,isoort

      REWIND INP

      read(inp,*,end=11) 

      DO 10 I=1,MAXOBS
            READ (INP,*,END=11) T(I),X(I)
            if (i.eq.1) then
               xmin =  X(1)
               xmax =  X(1)
            else
               if (X(I).lt.xmin) xmin = X(I)
               if (X(I).gt.xmax) xmax = X(I)
            endif
   10       CONTINUE
   11 N=I-1
      rN = N
         
 666  CLOSE(INP)
   20 FORMAT(' RECORD',I6,' READ: ', 2G20.9)
      RETURN
      END

c-------------------------------------------------------------------------------
      SUBROUTINE DOBSTA(N,T,X,XGEM,XVAR,IRES,sigma)
      
C     TEST EN STATISTISCHE GEGEVENS VAN DE DATA

      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION T(N),X(N)
      real*8    sigma

C      DO 1 I=1,N
C      WRITE(6,*) T(I),X(I)
C  1   CONTINUE

      NM1=N-1
      T1=T(1)
      TN=T(N)
 
C     BEREKENING VAN :

C        XGEM : GEMIDDELDE VAN DE WAARNEMINGSRESULTATEN
C        XVAR : VARIANTIE VAN DE WAARNEMINGSRESULTATEN
C        XSTD : STANDAARDAFWIJKING VAN DE WAARNEMINGSRESULTATEN
C        XMAX : DE MAXIMALE WAARGENOMEN MAGNITUDE
C        XMIN : DE MINIMALE WAARGENOMEN MAGNITUDE

C        DTMIN : HET KLEINSTE TIJDSINTERVAL TUSSEN DE WAARNEMINGEN
C        DTMAX : HET GROOTSTE TIJDSINTERVAL TUSSEN DE WAARNEMINGEN
C        DTVAR : VARIANTIE VAN DE TIJDSINTERVALLEN
C        DTSIG : STANDAARDAFWIJKING VAN DE TIJDSINTERVALLEN

C        TTOT : TOTALE TIJDSPANNE
 
      XSOM=X(1)
      XMAX=XSOM
      XMIN=XSOM
      XX=XSOM*XSOM
      
      DT=T(2)-T1
      DTMIN=DT
      DTMAX=DT
 
      DO 100 I=2,N

         XI=X(I)
         XSOM=XSOM+XI
         IF(XI.LT.XMIN) XMIN=XI
         IF(XI.GT.XMAX) XMAX=XI

         DT=T(I)-T(I-1)
         IF(DT.LT.DTMIN) DTMIN=DT
         IF(DT.GT.DTMAX) DTMAX=DT

  100 CONTINUE

C     DE TOTALE WAARNEMINGSTIJD, INVERSE EN GEMIDDELDE TUSSENTIJD
 
      TTOT=TN-T1
      TI=1./TTOT
      DTGEM=TTOT/NM1
 
C     DE TOTALE AMPLITUDE, HET GEMIDDELDE VAN DE WAARNEMINGSRESULTATEN
 
      XR=XMAX-XMIN
      XGEM=XSOM/N
 
C     DE SCHATTING VAN DE VARIANTIES

      SOMTT=0.
      SOMXX=(X(1)-XGEM)**2
      DO 200 I=2,N
         SOMTT=SOMTT+(T(I)-T(I-1)-DTGEM)**2
 200     SOMXX=SOMXX+(X(I)-XGEM)**2
         
      XVAR=SOMXX/NM1
      DTVAR=SOMTT/(N-2)
 
C     DE SCHATTING VAN DE STANDAARDAFWIJKING
 
      XSTD=SQRT(XVAR)
      DTSTD=SQRT(DTVAR)
 
      IF(IRES.NE.0) THEN
 
C     DE KENMERKEN VAN DE GEGEVENS
 
         WRITE(IRES,6) N,T1,TN,TTOT,TI,DTMIN,DTMAX,DTGEM,DTSTD,XMIN,
     &   XMAX,XR,XGEM,XVAR,XSTD
     
   6     FORMAT(1H1,'Kenmerken van de gegevens'//
     &   7X,'AANTAL : ',I6//
     &   7X,'WAARNEMINGSTIJDEN   VAN  ',F13.5,'   TOT  ',F13.5/
     &   7X,'TOTALE TIJD        : ',F10.5,'( =1/',F10.5,')'//
     &   7X,'TIJDSINTERVALLEN    VAN  ',F10.5,'   TOT  ',F10.5/
     &   7X,'GEMIDDELD          : ',F10.5,'(STD=',F10.5,')'//
     &   7X,'WAARNEMINGEN        VAN  ',F10.5,'   TOT  ',F10.5/
     &   7X,'RANGE              : ',F10.5/
     &   7X,'GEMIDDELDE         : ',F10.5/
     &   7X,'VARIANTIE          : ',F10.5/
     &   7X,'STANDAARDAFWIJKING : ',F10.5//)
 
      END IF

      sigma = XSTD
 
      RETURN
      END

      SUBROUTINE DOBSCO(N,Y,Y0)
 
C     VECTOR Y VAN DIMENSIE N CORRIGEREN MET Y0
 
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION Y(N)
 
      DO 10 I=1,N
            Y(I)=Y(I)-Y0
   10       CONTINUE

      RETURN
      END

      SUBROUTINE SCAR2 (N,X,T,F0,NF,DF,F1,S1,SS,SC,SS2,SC2)

 
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(N),T(N)
      DIMENSION F1(NF),S1(NF)
      DIMENSION SS(NF),SC(NF),SS2(NF),SC2(NF)
      DATA TWOPI,DTWO,DNUL/6.28318530717959D0,2.0D0,0.0D0/
      F = F0
      TPF = TWOPI * F
      TDF = TWOPI * DF
      TN = DFLOAT(N)
      TNSQ=TN*TN
 
      DO 20 K=1,NF
         SS(K)  = DNUL
         SC(K)  = DNUL
         SS2(K) = DNUL
         SC2(K) = DNUL
 20   CONTINUE
 
      DO 40 I=1,N

         A = T(I)
         AF0 = DMOD(A*TPF,TWOPI)
         S0 = DSIN(AF0)
         C0 = DCOS(AF0)
         S20 = DTWO * S0 * C0
         C20 = C0 * C0 - S0 * S0

         ADF = DMOD(A*TDF,TWOPI)
         SDF = DSIN(ADF)
         CDF = DCOS(ADF)
         S2DF = DTWO * SDF * CDF
         C2DF = CDF * CDF - SDF * SDF
         XI=X(I)
         C0X = C0 * XI
         S0X = S0 * XI
 
         DO 30 K=1,NF
            SS(K) = SS(K) + S0X
            SC(K) = SC(K) + C0X
            CTX=C0X
            C0X = CTX * CDF - S0X * SDF
            S0X = S0X * CDF + CTX * SDF
            SS2(K) = SS2(K) + S20
            SC2(K) = SC2(K) + C20
            C2T = C20
            C20 = C2T * C2DF - S20 * S2DF
            S20 = S20 * C2DF + C2T * S2DF
30          CONTINUE

40       CONTINUE 

      DO 50 K=1,NF
         SSK  =  SS(K)
         SS2K = SS2(K)
         SCK  =  SC(K)
         SC2K = SC2(K)
         
         F1(K)=F
         S1(K)=(SCK*SCK*(TN-SC2K)+SSK*SSK*(TN+SC2K)-DTWO*SSK*SCK*SS2K)/
     &      (TNSQ-SC2K*SC2K-SS2K*SS2K)
         F=F+DF
                  
50    CONTINUE
 
      RETURN
      END
 
      SUBROUTINE JUSTEL(N,X,T,F0,NF,DF,NB,NC,XVAR,XX,F1,S1)

C     BEREKENING VAN HET PERIODOGRAM VOLGENS JURKEVICH
C                                         OF STELLINGWERF
 
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION X(N),T(N),F1(NF),S1(NF)
      DIMENSION NBIN(1000),XB(1000),NH(1000),XH(1000)

      F=F0
       
C-------------------------------------------------------------------
C     NC = 1 : DE METHODE VAN JURKEVICH
C-------------------------------------------------------------------
 
      IF (NC.LE.1) THEN
 
         DF1=DFLOAT(N-NB)
 
         DO 16 K=1,NF
            DO 10 J=1,NB
               NBIN(J)=0
               XB(J)=0.0
   10       CONTINUE
 
C     BEREKENING VAN DE BININDEX VOOR ELKE WAARNEMING
 
            DO 12 I=1,N
 
C      DE PHASE PH VOOR EEN TIJDSTIP T(I)
 
               PH=DMOD(T(I)*F,1D0)
 
C      HET BINNUMMER VOOR DE IDE WAARNEMING
 
               JB=INT(PH*NB)+1
 
C      HET AANTAL WAARNEMINGEN IN DE JBDE BIN
 
               NBIN(JB)=NBIN(JB)+1
 
C      DE SOM VAN DE WAARNEMINGEN IN DE JBDE BIN
 
               XB(JB)=XB(JB)+X(I)
 
   12       CONTINUE
 
            DFRE=DF1
            VM=XX
 
            DO 14 J=1,NB
               NBJ=NBIN(J)
 
C     DE SOM VAN DE VARIANTIES BINNEN DE NIET-LEDIGE BINS
 
               IF (NBJ.NE.0) THEN
                  VM=VM-XB(J)*XB(J)/NBJ
               ELSE
 
C     HET AANTAL WAARNEMINGEN MIN HET AANTAL NIET-LEDIGE BINS
 
                 DFRE=DFRE+1.0
               END IF
 
   14       CONTINUE
 
C     XVAR: DE SCHATTING VAN DE VARIANTIE, BEREKEND IN HET HOOFDPROGR.
 
C     OPVULLEN VAN DE MATRIX MET FREQUENTIE EN TESTSTATISTIEK
 
            F1(K) = F
            S1(K) = VM/DFRE/XVAR
            F=F+DF
             
   16    CONTINUE
 
      ELSE
 
C---------------------------------------------------------------------
C     NC>1 : DE METHODE VAN STELLINGWERF
C---------------------------------------------------------------------
 
C     OPMERKING : EEN BIN-COVER IS HET FASE-INTERVAL/(NB * NC)
C                 EEN BIN IS HET FASE-INTERVAL/NB
 
         NBC=NB*NC
         NC1=NC-1
         NBC1=NBC-NC1
         NBC2=NBC1+1
         DFC=DFLOAT(N*NC-NBC)
         XXNC=XX*NC

         F=F0
          
         DO 40 K=1,NF
            DO 20 J=1,NBC
               NBIN(J)=0
               XB(J)=0.0
   20       CONTINUE
 
            DO 22 I=1,N
 
C     DE FASE PH VOOR EEN TIJDSTIP T(I)
 
               PH=DMOD(T(I)*F,1D0)
 
C     HET BINNUMMER VAN DE IDE WAARNEMING
 
               JB=INT(PH*NBC)+1
 
C     HET AANTAL WAARNEMINGEN IN DE JBDE BIN-COVER
 
               NBIN(JB)=NBIN(JB)+1
 
C     DE SOM VAN HET AANTAL WAARNEMINGEN IN DE JBDE BIN-COVER
 
               XB(JB)=XB(JB)+X(I)
 
   22       CONTINUE
 
C     XH : MATRIX MET ALS ELEMENTEN DE SOM VAN DE WAARNEMINGEN IN
C          EENZELFDE BIN-COVER
C     NH : MATRIX MET ALS ELEMENTEN HET AANTAL WAARNEMINGEN IN EEN-
C          ZELFDE BIN-COVER
 
            DO 24 L=1,NC1
               XH(L)=XB(L)
               NH(L)=NBIN(L)
   24       CONTINUE
 
C    BEREKENING VOOR ELK VAN DE NC COVERS : HET AANTAL WAARNEMINGEN
C    EN DE SOM VAN DE WAARNEMINGEN PER BIN
 
            DO 28 J=1,NBC1
               J1=J+1
               JNC1=J+NC1
               DO 26 L=J1,JNC1
                  XB(J)=XB(J)+XB(L)
                  NBIN(J)=NBIN(J)+NBIN(L)
   26          CONTINUE
   28       CONTINUE
 
C      ALS ER AAN HET EINDE VAN HET FASE-INTERVAL ONVOLDOENDE BIN-
C      COVERS ZIJN VOOR EEN VOLLEDIGE BIN MOETEN ER VOORAAN NOG NC - J
C      BINCOVERS BIJGENOMEN WORDEN
 
            DO 34 J=NBC2,NBC
               J1=J+1
               DO 30 L=J1,NBC
                  XB(J)=XB(J)+XB(L)
                  NBIN(J)=NBIN(J)+NBIN(L)
   30          CONTINUE
               J2=J-NBC1
               DO 32 L=1,J2
                  XB(J)=XB(J)+XH(L)
                  NBIN(J)=NBIN(J)+NH(L)
   32          CONTINUE
   34       CONTINUE
 
            DFRE=DFC
            VM=XXNC
 
            DO 36 J=1,NBC
               NBJ=NBIN(J)
 
C     DE SOM VAN DE VARIANTIES IN DE NIET-LEDIGE BINS
 
               IF (NBJ.NE.0) THEN
                  VM=VM-XB(J)*XB(J)/NBJ
               ELSE
                  DFRE=DFRE+1.0
               END IF
 
   36       CONTINUE
 
C     OPVULLEN VAN DE MATRIX MET FREQUENTIE F EN TESTSTATISTIEK S
 
            F1(K) = F
            S1(K) = VM/DFRE/XVAR
            F=F+DF
   40    CONTINUE
 
      END IF
 
      RETURN
      END


















