      PROGRAM harmplot_student

C     Progamme that fits harmonic functions 
C     Version 1.0: copy of PC version 2.1 : 17/06/93 
C     Version 1.1: JC 23/02/96
C     Max obs = 10001 (fit limits limits :svdfit!)
C     Max frequencies = 11 (dharmo)
C     Max unknows = 99 (Including constant, and two unknowns for each
C                       harmonic !)
c      data input routine: dlees

c Author: Dr. Jan Cuypers, ROB; revision: Dr. P. De Cat, KULeuven

      IMPLICIT REAL*8(A-H,O-Z)
      
      PARAMETER (tpi=6.28318530717959D0)
      PARAMETER (MAXOBS=75000,MAXF=11,MAXT=99)
      PARAMETER (INP=10,IOUT=11,ITEST=6)
      parameter (maxdatanacht=30000)
      parameter (maxnachten=50)
      character*70 string, infile, fracvarfile, schrijffile, psfile
      character    cfreq1*7, cfreq10*8
      character psnaam1*20, psnaam10*21, resfile*70
      character cfracvar*5, charfreq(MAXF)*24
      DIMENSION T(MAXOBS),X(MAXOBS),SIG(MAXOBS)
      DIMENSION U(MAXOBS,MAXT),V(MAXT,MAXT),W(MAXT),A(MAXT)
      DIMENSION CVM(MAXT,MAXT)
      integer   nacht, ndatanacht(maxdatanacht)
      integer   ndata
      integer   verder, maxpos, foutaanw, fouten
      integer   plot, japs, mom
      real*8    result, fase, maxampli, ampli, fout(MAXOBS), fouti
      real*8    fracvar,foutampli, phase, foutphase
      real      maxfit, minfit, maxres, minres, cfit(101), lijn(101)
      real      res(MAXOBS), plotphase(MAXOBS), cplotphase(101)
      real      varb(MAXOBS), varo(MAXOBS), var(MAXOBS)
      real      maxnacht, minnacht
      real      plotnachtphase(maxnachten,maxdatanacht)
      real      nachtvar(maxnachten,maxdatanacht)
      real      cnachtfit(maxnachten,101)
 

      EXTERNAL DHARMO

      COMMON/oud/F(11),NFI(11),NF

      COMMON/lijn1/minfit,maxfit,ndata,japs,plot,mom,psnaam1,psnaam10
      COMMON/lijn2/plotphase,var,varo,varb,charfreq,cplotphase,cfit
      COMMON/lijn3/fracvar,minres,maxres,lijn,res,cfracvar
      COMMON/lijn4/schrijffile,infile
      COMMON/lijn5/minnacht,maxnacht,ndatanacht
      COMMON/lijn6/cnachtfit,plotnachtphase,nachtvar,nacht
      COMMON/lijn7/resfile

      n_files = 0

 10   write(6,*) 'Give the name of the input file (eof to end)'
      read (5,*) infile
      write(6,*)
      if (infile.eq."eof") goto 200

 5490 write(6,*) 'Are there errors in the inputfile? (1/0)'
      read(5,*)  foutaanw
      if ((foutaanw.ne.1).and.(foutaanw.ne.0)) goto 5490
      write(6,*)
      if (foutaanw.eq.1) then
          fouten = 1
      else
          fouten = 0
      endif
  
      OPEN (inp, FILE=infile, STATUS='OLD')
      read(inp,11) string
  11  format (A)   
      write(6,*) 'Header in file: ',string
      write(6,*)

      CALL DLEES(INP,MAXOBS,N,T,X,fout,fouten)
      
      IF (N.LE.0) then
         write(6,*) 'N=0'
         goto 10
      end if

 20   WRITE(6,*) 'If phase 0 is not T(1), give N'
      read (5,*) string
      if (string(1:3).eq."eof") goto 10
      
      if (string(1:1).eq."N") then
         WRITE(6,*) 'Give time of phase 0 : '
         read (5,*) T0
      ELSE
         T0=T(1)
      END IF
      CALL DOBSCO(N,T,T0)
 123  write(6,*)

      WRITE(6,*) 'Number of frequencies to fit: '
      READ(5,*) NF
      MH=1
      
      DO 30 I=1,NF
          WRITE(6,*) 'Frequency nr.',I,',number of harmonics: '
          READ(5,*) F(I),NFI(I)
          MH=MH+2*NFI(I)
  30      CONTINUE
      MA=MH

      n_files = n_files+1
      if (F(1).ge.10.0) then
           write(cfreq10,3816) F(1)
           write(6,*) cfreq10
           schrijffile = 'solution.'//cfreq10//'.fv'
           psfile      = 'solution.'//cfreq10//'.ps'
           resfile     = 'solution.'//cfreq10//'.res'
 3816      format (f8.5)
      else
           write(cfreq1,3817) F(1)
           write(6,*) cfreq1
           schrijffile = 'solution.'//cfreq1//'.fv'
           psfile      = 'solution.'//cfreq1//'.ps'
           resfile     = 'solution.'//cfreq1//'.res'
 3817      format (f7.5)
      endif
      write(6,*) schrijffile
      OPEN (Iout,FILE=schrijffile)
      
      DO 40 I=1,N
         SIG(I)=1.
 40      CONTINUE
            
 45   WRITE(ITEST,*) 'HARMONIC FIT'
 
      MP=MAXOBS
      NP=MAXT
      CALL SVDFIT(T,X,SIG,N,A,MA,U,V,W,MP,NP,CHISQ,DHARMO)
      CALL SVDVAR(V,MA,MAXT,W,CVM,MAXT)

      write(Iout,*) infile, schrijffile
      write(Iout,*)
      write(Iout,*)

      CALL DOBSTA(N,T,X,XGEM,XVAR,itest,Iout)
      
      write(Iout,*)
      write(Iout,*) 'CHARACTERISTICS OF THE FIT'
      write(Iout,*) 
      write(Iout,*) 'number of frequencies : ', NF
      write(Iout,*)

      write (ITEST,51) A(1),CVM(1,1),SQRT(CVM(1,1)*CHISQ/N)
      write (Iout,51)  A(1),CVM(1,1),SQRT(CVM(1,1)*CHISQ/N)

      JF=2
      maxampli = 0
      maxpos   = 0
      
      DO 50 I=1,NF
      
        write(ITEST,9742) I,F(I),NFI(I),NFI(I)
        write(Iout,9742)  I,F(I),NFI(I),NFI(I)
        write(15,9742)    I,F(I),NFI(I),NFI(I)
 9742   format(1x,'FREQ',i2,' = ',f11.8,'(',i2,') with ',i2,
     ;         ' harmonics')
              
        DO 50 J=1,NFI(I)
         write(ITEST,52) A(JF),CVM(JF,JF)
     &                  ,SQRT(CVM(JF,JF)*CHISQ/N)
         write(ITEST,53) A(JF+1),CVM(JF+1,JF+1)
     &                  ,SQRT(CVM(JF+1,JF+1)*CHISQ/N)
         ampli = SQRT(A(JF)**2+A(JF+1)**2)
         foutampli = (abs(A(JF))*SQRT(CVM(JF,JF)*CHISQ/N) + 
     &               abs(A(JF+1))*SQRT(CVM(JF+1,JF+1)*CHISQ/N))/ampli
         write(ITEST,54) J*F(I),ampli,foutampli

         phase = datan(a(jf)/a(jf+1))
         if ((a(jf+1).lt.0) .and. (a(jf).gt.0)) phase=phase+tpi/2.
         if ((a(jf+1).lt.0) .and. (a(jf).lt.0)) phase=phase-tpi/2.
         phase=phase/tpi
         if (phase.lt.0) phase=phase+1.
         foutphase=abs(A(JF+1)*SQRT(CVM(JF,JF)*CHISQ/N)-
     &   A(JF)*SQRT(CVM(JF,JF)*CHISQ/N))/ampli**2/tpi
         write(ITEST,56) J*F(I),phase,foutphase

         if (ampli.gt.maxampli) then
            maxampli = ampli
            maxpos   = I
         endif

         write(Iout,52) A(JF),CVM(JF,JF)
     &                  ,SQRT(CVM(JF,JF)*CHISQ/N)
         write(Iout,53) A(JF+1),CVM(JF+1,JF+1)
     &                  ,SQRT(CVM(JF+1,JF+1)*CHISQ/N)
         write(Iout,54) J*F(I),ampli,foutampli
c         write(15,54)   J*F(I),ampli,foutampli
         write(Iout,56) J*F(I),phase,foutphase
c         write(6,56)   J*F(I),phase,foutphase
         JF=JF+2
 50      CONTINUE

      write(ITEST,55) CHISQ
      write(Iout,55)  CHISQ

      write(Iout,*) 
      write(Iout,8563) maxpos 
 8563 format(' frequency with biggest amplitude : ',i2)            
      write(Iout,*)
      write(Iout,*)
      write(Iout,*) 'OUTPUT FOR THE MOMENTS OF OBSERVATION'
      write(Iout,*)
      write(Iout,*) '     time         residual     variable',
     ;              '      error         fit         phase'

 51   FORMAT (1X,'constant : ',F15.5,9X,'(',F9.5,' ->',F9.5,')')
 52   FORMAT (4X,' sine    * ',3X,F15.5,4X,'(',F9.5,' ->',F9.5,')')
 53   FORMAT (4X,' cosine  * ',3X,F15.5,4X,'(',F9.5,' ->',F9.5,')')    
 54   FORMAT (4X,'frequency ->  ',F12.8,2X,'amplitude:  ',F15.5,
     & 3X,'s.e.:' ,F10.4)
 56   FORMAT (4X,'frequency ->  ',F12.8,2X,'phase(in 2pi rad): '
     & ,F8.5,3X,'s.e.:' ,F10.4)
 55   FORMAT (1X,'res. sum : ',F20.8)
             
        somxi=0
        somresi=0

      DO 130 I=1,N
         TI=T(I)
         CALL DHARMO(TI,W,MAXT)     
         FIT=0.
         DO 110 J=1,MA    
           FIT=FIT+W(J)*A(J)
 110     CONTINUE
         DO 120 J=1,NF
           W(J)=MOD(TI*F(J),1)
 120     CONTINUE
         XI=X(I)
         fouti=fout(I)
         RESI=XI-FIT
         somxi=somxi+xi
         somresi=somresi+resi*resi
         TI=TI+T0
         if (TI.gt.2400000.0) TI = TI-2400000.0
         WRITE(IOUT,131) TI,RESI,XI,fouti,FIT, (W(J),J=1,NF)
 130  CONTINUE
       gemxi=somxi/n
       ssg=0

       do 140 i=1,n
        ssg=ssg+(x(i)-gemxi)*(x(i)-gemxi)
 140     continue
       fracvar=(ssg-somresi)/ssg

      write(6,*)
      write(6,*) 'Residuals and other output written in file ', 
     v     schrijffile
      write(6,'(a10,f7.4)')  'fracvar = ', fracvar

      write(Iout,*)
      write(Iout,*)
      write(Iout,'(a11,f7.4)')  ' FRACVAR = ', fracvar
      write(Iout,*)
      write(Iout,*)


      write(15,6486) fracvar, schrijffile
 6486 format(4x,'FRACVAR : ',f7.4,5x,'file : ',a40)      
      write(15,*)

      write(Iout,*) 'CALCULATED FIT'
      write(Iout,*)
      write(Iout,*) '        fit         phases'

      DO I=1,100
         fase = (I-1)*0.01
         TI   = fase/F(maxpos)
         CALL DHARMO(TI,W,MAXT)     
         result=0.
         DO J=1,MA    
           result=result+W(J)*A(J)
         ENDDO
         DO J=1,NF
           W(J)=MOD(TI*F(J),1)
         ENDDO
         WRITE(IOUT,131) result, (W(J),J=1,NF)
      ENDDO

      close(IOUT)


      if (NF.eq.1) then
         write(6,*)
 2759    write(6,*) 'Do you want to make a phaseplot with this '//
     v              'frequency? (1/0)'      
         read(5,*)  plotje
         write(6,*)
         if ((plotje.ne.1).and.(plotje.ne.0)) goto 2759
         if (plotje.eq.1) then
            call plotten
         endif
      endif
      
      write(6,*)
 124  write(6,*) '-----------------------------------------------'
      write(6,*) 'Do you want to check another frequency for this'
      write(6,*) 'inputfile ? (same epoch) => yes=1, no=0'      
      write(6,*) '-----------------------------------------------'
      read(5,*)  verder
      write(6,*)

      if (verder.eq.1) then
          goto 123
      else 
          if (verder.ne.0) then
              goto 124
          endif
      endif
      goto 10
 200  continue     
 131  FORMAT(1X,f13.7,15F13.5)
      stop
      END

c-------------------------------------------------------------------------------
c     subroutines
c-------------------------------------------------------------------------------
      SUBROUTINE DOBSCO(N,Y,Y0)
 
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION Y(N)
 
      DO 10 I=1,N
            Y(I)=Y(I)-Y0
   10       CONTINUE

      RETURN
      END
c-------------------------------------------------------------------------------
      SUBROUTINE DLEES(INP,MAXOBS,N,T,X,fout,fouten)
 
      IMPLICIT REAL*8(A-H,O-Z)
      integer   fouten
      real*8    fout(MAXOBS)
      DIMENSION T(MAXOBS),X(MAXOBS)
 
      if (fouten.eq.1) then 
           DO I=1,MAXOBS
                 READ (INP,*,End=10,err=10) T(I),X(I),fout(I)
           ENDDO
 10        N=I-1
           CLOSE(INP)
      else
           DO I=1,MAXOBS
                 READ (INP,*,End=11,err=11) T(I),X(I)
                 fout(I) = 0.0
           ENDDO
 11        N=I-1
           CLOSE(INP)
      endif
 
      RETURN
      END
c-------------------------------------------------------------------------------
      SUBROUTINE SVDFIT(X,Y,SIG,NDATA,A,MA,U,V,W,MP,NP,CHISQ,FUNCS)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER(NMAX=10001,MMAX=99,TOL=1.E-5)
      DIMENSION X(NDATA),Y(NDATA),SIG(NDATA),A(MA),V(NP,NP),
     & U(MP,NP),W(NP),B(NMAX),AFUNC(MMAX)
      EXTERNAL FUNCS
      DO 12 I=1,NDATA
        CALL FUNCS(X(I),AFUNC,MA)
        TMP=1./SIG(I)
        DO 11 J=1,MA
          U(I,J)=AFUNC(J)*TMP
11      CONTINUE
        B(I)=Y(I)*TMP
12    CONTINUE
      CALL SVDCMP(U,NDATA,MA,MP,NP,W,V)
      WMAX=0.
      DO 13 J=1,MA
        IF(W(J).GT.WMAX)WMAX=W(J)
13    CONTINUE
      THRESH=TOL*WMAX
      DO 14 J=1,MA
        IF(W(J).LT.THRESH)W(J)=0.
14    CONTINUE
      CALL SVBKSB(U,W,V,NDATA,MA,MP,NP,B,A)
      CHISQ=0.
      DO 16 I=1,NDATA
        CALL FUNCS(X(I),AFUNC,MA)
        SUM=0.
        DO 15 J=1,MA
          SUM=SUM+A(J)*AFUNC(J)
15      CONTINUE
        CHISQ=CHISQ+((Y(I)-SUM)/SIG(I))**2
16    CONTINUE
      RETURN
      END
c-------------------------------------------------------------------------------
      SUBROUTINE SVDVAR(V,MA,NP,W,CVM,NCVM)

      IMPLICIT REAL*8(A-H,O-Z)

      PARAMETER (MMAX=99)
      DIMENSION V(NP,*),W(*),CVM(NCVM,NCVM),WTI(MMAX)

      DO 11 I=1,MA
        WTI(I)=0.
        IF(W(I).NE.0.) WTI(I)=1./(W(I)*W(I))
11    CONTINUE
      DO 14 I=1,MA
        DO 13 J=1,I
          SUM=0.
          DO 12 K=1,MA
            SUM=SUM+V(I,K)*V(J,K)*WTI(K)
12        CONTINUE
          CVM(I,J)=SUM
          CVM(J,I)=SUM
13      CONTINUE
14    CONTINUE
      RETURN
      END
c-------------------------------------------------------------------------------
      SUBROUTINE SVDCMP(A,M,N,MP,NP,W,V)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (NMAX=99)
      DIMENSION A(MP,*),W(*),V(NP,*),RV1(NMAX)
      G=0.0
      SCALE=0.0
      ANORM=0.0
      DO 25 I=1,N
        L=I+1
        RV1(I)=SCALE*G
        G=0.0
        S=0.0
        SCALE=0.0
        IF (I.LE.M) THEN
          DO 11 K=I,M
            SCALE=SCALE+ABS(A(K,I))
11        CONTINUE
          IF (SCALE.NE.0.0) THEN
            DO 12 K=I,M
              A(K,I)=A(K,I)/SCALE
              S=S+A(K,I)*A(K,I)
12          CONTINUE
            F=A(I,I)
            G=-SIGN(SQRT(S),F)
            H=F*G-S
            A(I,I)=F-G
            IF (I.NE.N) THEN
              DO 15 J=L,N
                S=0.0
                DO 13 K=I,M
                  S=S+A(K,I)*A(K,J)
13              CONTINUE
                F=S/H
                DO 14 K=I,M
                  A(K,J)=A(K,J)+F*A(K,I)
14              CONTINUE
15            CONTINUE
            ENDIF
            DO 16 K= I,M
              A(K,I)=SCALE*A(K,I)
16          CONTINUE
          ENDIF
        ENDIF
        W(I)=SCALE *G
        G=0.0
        S=0.0
        SCALE=0.0
        IF ((I.LE.M).AND.(I.NE.N)) THEN
          DO 17 K=L,N
            SCALE=SCALE+ABS(A(I,K))
17        CONTINUE
          IF (SCALE.NE.0.0) THEN
            DO 18 K=L,N
              A(I,K)=A(I,K)/SCALE
              S=S+A(I,K)*A(I,K)
18          CONTINUE
            F=A(I,L)
            G=-SIGN(SQRT(S),F)
            H=F*G-S
            A(I,L)=F-G
            DO 19 K=L,N
              RV1(K)=A(I,K)/H
19          CONTINUE
            IF (I.NE.M) THEN
              DO 23 J=L,M
                S=0.0
                DO 21 K=L,N
                  S=S+A(J,K)*A(I,K)
21              CONTINUE
                DO 22 K=L,N
                  A(J,K)=A(J,K)+S*RV1(K)
22              CONTINUE
23            CONTINUE
            ENDIF
            DO 24 K=L,N
              A(I,K)=SCALE*A(I,K)
24          CONTINUE
          ENDIF
        ENDIF
        ANORM=MAX(ANORM,(ABS(W(I))+ABS(RV1(I))))
25    CONTINUE
      DO 32 I=N,1,-1
        IF (I.LT.N) THEN
          IF (G.NE.0.0) THEN
            DO 26 J=L,N
              V(J,I)=(A(I,J)/A(I,L))/G
26          CONTINUE
            DO 29 J=L,N
              S=0.0
              DO 27 K=L,N
                S=S+A(I,K)*V(K,J)
27            CONTINUE
              DO 28 K=L,N
                V(K,J)=V(K,J)+S*V(K,I)
28            CONTINUE
29          CONTINUE
          ENDIF
          DO 31 J=L,N
            V(I,J)=0.0
            V(J,I)=0.0
31        CONTINUE
        ENDIF
        V(I,I)=1.0
        G=RV1(I)
        L=I
32    CONTINUE
      DO 39 I=N,1,-1
        L=I+1
        G=W(I)
        IF (I.LT.N) THEN
          DO 33 J=L,N
            A(I,J)=0.0
33        CONTINUE
        ENDIF
        IF (G.NE.0.0) THEN
          G=1.0/G
          IF (I.NE.N) THEN
            DO 36 J=L,N
              S=0.0
              DO 34 K=L,M
                S=S+A(K,I)*A(K,J)
34            CONTINUE
              F=(S/A(I,I))*G
              DO 35 K=I,M
                A(K,J)=A(K,J)+F*A(K,I)
35            CONTINUE
36          CONTINUE
          ENDIF
          DO 37 J=I,M
            A(J,I)=A(J,I)*G
37        CONTINUE
        ELSE
          DO 38 J= I,M
            A(J,I)=0.0
38        CONTINUE
        ENDIF
        A(I,I)=A(I,I)+1.0
39    CONTINUE
      DO 49 K=N,1,-1
        DO 48 ITS=1,30
          DO 41 L=K,1,-1
            NM=L-1
            IF ((ABS(RV1(L))+ANORM).EQ.ANORM)  GO TO 2
            IF ((ABS(W(NM))+ANORM).EQ.ANORM)  GO TO 1
41        CONTINUE
1         C=0.0
          S=1.0
          DO 43 I=L,K
            F=S*RV1(I)
            IF ((ABS(F)+ANORM).NE.ANORM) THEN
              G=W(I)
              H=SQRT(F*F+G*G)
              W(I)=H
              H=1.0/H
              C= (G*H)
              S=-(F*H)
              DO 42 J=1,M
                Y=A(J,NM)
                Z=A(J,I)
                A(J,NM)=(Y*C)+(Z*S)
                A(J,I)=-(Y*S)+(Z*C)
42            CONTINUE
            ENDIF
43        CONTINUE
2         Z=W(K)
          IF (L.EQ.K) THEN
            IF (Z.LT.0.0) THEN
              W(K)=-Z
              DO 44 J=1,N
                V(J,K)=-V(J,K)
44            CONTINUE
            ENDIF
            GO TO 3
          ENDIF
          IF (ITS.EQ.30) PAUSE 'No convergence in 30 iterations'
          X=W(L)
          NM=K-1
          Y=W(NM)
          G=RV1(NM)
          H=RV1(K)
          F=((Y-Z)*(Y+Z)+(G-H)*(G+H))/(2.0*H*Y)
          G=SQRT(F*F+1.0)
          F=((X-Z)*(X+Z)+H*((Y/(F+SIGN(G,F)))-H))/X
          C=1.0
          S=1.0
          DO 47 J=L,NM
            I=J+1
            G=RV1(I)
            Y=W(I)
            H=S*G
            G=C*G
            Z=SQRT(F*F+H*H)
            RV1(J)=Z
            C=F/Z
            S=H/Z
            F= (X*C)+(G*S)
            G=-(X*S)+(G*C)
            H=Y*S
            Y=Y*C
            DO 45 NM=1,N
              X=V(NM,J)
              Z=V(NM,I)
              V(NM,J)= (X*C)+(Z*S)
              V(NM,I)=-(X*S)+(Z*C)
45          CONTINUE
            Z=SQRT(F*F+H*H)
            W(J)=Z
            IF (Z.NE.0.0) THEN
              Z=1.0/Z
              C=F*Z
              S=H*Z
            ENDIF
            F= (C*G)+(S*Y)
            X=-(S*G)+(C*Y)
            DO 46 NM=1,M
              Y=A(NM,J)
              Z=A(NM,I)
              A(NM,J)= (Y*C)+(Z*S)
              A(NM,I)=-(Y*S)+(Z*C)
46          CONTINUE
47        CONTINUE
          RV1(L)=0.0
          RV1(K)=F
          W(K)=X
48      CONTINUE
3       CONTINUE
49    CONTINUE
      RETURN
      END
c-------------------------------------------------------------------------------
      SUBROUTINE SVBKSB(U,W,V,M,N,MP,NP,B,X)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (NMAX=99)
      DIMENSION U(MP,*),W(*),V(NP,*),B(*),X(*),TMP(NMAX)
      DO 12 J=1,N
        S=0.
        IF(W(J).NE.0.)THEN
          DO 11 I=1,M
            S=S+U(I,J)*B(I)
11        CONTINUE
          S=S/W(J)
        ENDIF
        TMP(J)=S
12    CONTINUE
      DO 14 J=1,N
        S=0.
        DO 13 JJ=1,N
          S=S+V(J,JJ)*TMP(JJ)
13      CONTINUE
        X(J)=S
14    CONTINUE
      RETURN
      END
c-------------------------------------------------------------------------------
      SUBROUTINE DOBSTA(N,T,X,XGEM,XVAR,IRES,IOUT)
      
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION T(N),X(N)
 
      NM1=N-1
      T1=T(1)
      TN=T(N)
 
      XSOM=X(1)
      XMAX=XSOM
      XMIN=XSOM
      XX=XSOM*XSOM
      
      DT=T(2)-T1
      DTMIN=DT
      DTMAX=DT
 
      DO 100 I=2,N

         XI=X(I)
         XSOM=XSOM+XI
         IF(XI.LT.XMIN) XMIN=XI
         IF(XI.GT.XMAX) XMAX=XI

         DT=T(I)-T(I-1)
         IF(DT.LT.DTMIN) DTMIN=DT
         IF(DT.GT.DTMAX) DTMAX=DT

  100 CONTINUE

      TTOT=TN-T1
      TI=1./TTOT
      DTGEM=TTOT/NM1
 
      XR=XMAX-XMIN
      XGEM=XSOM/N
 
      SOMTT=0.
      SOMXX=(X(1)-XGEM)**2
      DO 200 I=2,N
         SOMTT=SOMTT+(T(I)-T(I-1)-DTGEM)**2
 200     SOMXX=SOMXX+(X(I)-XGEM)**2
         
      XVAR=SOMXX/NM1
      DTVAR=SOMTT/(N-2)
 
      XSTD=SQRT(XVAR)
      DTSTD=SQRT(DTVAR)
 
      IF(IRES.NE.0) THEN
 
         write(Iout,6) N,T1,TN,TTOT,TI,DTMIN,DTMAX,DTGEM,DTSTD,XMIN,
     &   XMAX,XR,XGEM,XVAR,XSTD
     
   6     FORMAT('CHARACTERISTICS OF THE OBSERVATIONS'//
     &   7X,'number            : ',I6/
     &   7X,'observing time    from  ',F15.7,' until  ',F15.7/
     &   7X,'total time        : ',F15.7,'( =1/',F15.7,')'/
     &   7X,'time intervals    from  ',F15.7,' until  ',F15.7/
     &   7X,'average           : ',F15.7,'(STD=',F15.7,')'/
     &   7X,'observations      from  ',F15.7,' until  ',F15.7/
     &   7X,'range             : ',F15.7/
     &   7X,'average           : ',F15.7/
     &   7X,'variance          : ',F15.7/
     &   7X,'standard deviation: ',F15.7//)
       END IF
 
      RETURN
      END
c-------------------------------------------------------------------------------
      SUBROUTINE DHARMO(X,H,NH)

c     version 1.0 JC 15/02/96: adapted pc version 
c                              (11 frequencies maximum)

      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (twopi=6.28318530717959D0)
      Parameter (nf_max = 11)
      COMMON/oud/F(nf_max),NFI(nf_max),NF
      
      DIMENSION H(NH)
      H(1)=1
      IH=2
      DO 220 I=1,NF
         TXF=twopi*X*F(I)
         DO 210 J=1,NFI(I)    
           ARG=J*TXF
           H(IH)  = SIN(ARG)
           H(IH+1)= COS(ARG)      
           IH=IH+2
 210       CONTINUE
 220     CONTINUE  
      RETURN
      END
c-------------------------------------------------------------------------------
      subroutine plotten

      parameter (MAXOBS=75000,MAXF=11)
      parameter (maxdatanacht=30000)
      parameter (maxnachten=50)
      parameter (tijdverschil=10)

      real*8    hjd(MAXOBS), fout(MAXOBS), gew(MAXOBS), ress(MAXOBS)
      character schrijffile*70,infile*70
      integer   nacht, hjd2, hjd1, ndatanacht(maxdatanacht)
      integer   i, j ,k, ndata, nfreq, nharm(MAXF), bigamp
      integer   plot, japs, mom
      real      fit, var(MAXOBS)
      real      maxfit, minfit, maxres, minres, cfit(101), lijn(101)
      real      res(MAXOBS), plotphase(MAXOBS), cplotphase(101)
      real      varb(MAXOBS), varo(MAXOBS)
      real      maxnacht, minnacht, maxfi,minfi,maxre,minre
      real      plotnachtphase(maxnachten,maxdatanacht)
      real      nachtvar(maxnachten,maxdatanacht)
      real      cnachtfit(maxnachten,101)
      real*8    const, freq(MAXF,MAXF), ampli(MAXF,MAXF)
      real*8    asin(MAXF,MAXF), acos(MAXF,MAXF)
      real*8    ressum,  phase(MAXF)
      real*8    fracvar, cphase(MAXF)
      real*8    verschilres, verschildata
      character naam*20, charfreq(MAXF)*24, psnaam1*20, psnaam10*21
      character cfreq1*16, cfreq10*17, cfracvar*5, resfile*70

      COMMON/lijn1/minfit,maxfit,ndata,japs,plot,mom,psnaam1,psnaam10
      COMMON/lijn2/plotphase,var,varo,varb,charfreq,cplotphase,cfit
      COMMON/lijn3/fracvar,minres,maxres,lijn,res,cfracvar
      COMMON/lijn4/schrijffile,infile
      COMMON/lijn5/minnacht,maxnacht,ndatanacht
      COMMON/lijn6/cnachtfit,plotnachtphase,nachtvar,nacht
      COMMON/lijn7/resfile


      open(64,file=resfile)

      maxres = 0.0
      minres = 0.0

      do i = 1, 11
           charfreq(i) = ' '
      enddo

      open(11,file=schrijffile)
      write(6,*)
      
      read(11,*,end=1001) 
      read(11,'(1x,a20)',end=1001) naam
      write(6,*) naam

      do j = 1, 4
           read(11,*,end=1001) 
c           write(6,*) 
      enddo

      read(11,101,end=1001)     ndata 
 101  format(27x,i6)

      do j = 1, 14
           read(11,*,end=1001) 
      enddo

      read(11,102,end=1001)     nfreq
 102  format(25x,i3)
 
      read(11,*,end=1001)
      read(11,103,end=1001) const
 103  format(11x,f15.5)

      DO i = 1, nfreq
           read(11,104,end=1001) charfreq(i),nharm(i)
 104       format(1x,a24,6x,i2)
           DO k = 1, nharm(i)
              read(11,105,end=1001) asin(i,k) 
              read(11,105,end=1001) acos(i,k) 
 105          format(18x,f15.5)
              read(11,106,end=1001) freq(i,k), ampli(i,k)
              read(11,*)
 106          format(17x,f13.8,14x,f15.5)
           ENDDO
           if (freq(1,1).ge.10.0) then
              write(cfreq10,'(a17)') naam
              psnaam10 = cfreq10//'.ps'
              plot = 1
           else
              write(cfreq1,'(a16)') naam
              psnaam1 = cfreq1//'.ps'
              plot = 0
           endif
      ENDDO
      read(11,107,end=1001) ressum
 107  format(12x,f20.8)

      read(11,*,end=1001)
      read(11,108,end=1001) bigamp
      write(6,*)
 108  format(36x,i2)

      do j = 1, 5
           read(11,*,end=1001) 
      enddo

      maxfit = -1.0e10
      minfit =  1.0e10

      write(64,'(i4,1x,f12.8,2x,a60)') ndata, freq(1,1), infile

      nacht = 1
      l     = 1

      read(11,109,end=1001) hjd(1), ress(1), var(1), fout(1), fit,
     &                      (phase(k),k=1,nfreq)
      res(1) = ress(1)
      if (phase(bigamp).lt.0) then
         phase(bigamp) = phase(bigamp) + 1
      endif
      plotphase(1)            = phase(bigamp)
      plotnachtphase(nacht,l) = phase(bigamp)
      nachtvar(nacht,l)       = var(1)

      if (fout(1).eq.0.0) then
          gew(1) = 1.0000
      else
           if (fout(1).gt.0.5) then
             gew(1) = 0.5/fout(1)
           else
             gew(1) = 1.0000
           endif
      endif     
      write(64,333) hjd(1), ress(1), fout(1), gew(1), fit, var(1)
 333  format(f13.7,1x,f15.5,1x,f10.5,1x,f10.5,1x,f14.4,1x,f14.4)


      if (ress(1).gt.maxres) then
          maxres = ress(1)
      endif
      if (ress(1).lt.minres) then
          minres = ress(1)
      endif
      varb(1) = var(1) + fout(1)
      varo(1) = var(1) - fout(1)
      if (varb(1).gt.maxfit) then
          maxfit = varb(1)
      endif
      if (varo(1).lt.minfit) then
          minfit = varo(1)
      endif


      DO i = 2, ndata
           read(11,109,end=1001) hjd(i), ress(i), var(i), fout(i), fit,
     &                           (phase(k),k=1,nfreq)
           res(i) = ress(i)
           if (phase(bigamp).lt.0) then
              phase(bigamp) = phase(bigamp) + 1
           endif
           plotphase(i) = phase(bigamp)
           hjd2 = dint(hjd(i))
           hjd1 = dint(hjd(i-1))
           if ((hjd2-hjd1).ge.tijdverschil) then
                ndatanacht(nacht) = l
                nacht = nacht + 1
                l     = 1
           else
                l     = l + 1
           endif
           plotnachtphase(nacht,l) = phase(bigamp)
           nachtvar(nacht,l)       = var(i)

           if (fout(i).eq.0.0) then
               gew(i) = 1.0000
           else
                if (fout(i).gt.0.5) then
                  gew(i) = 0.5/fout(i)
                else
                  gew(i) = 1.0000
                endif
           endif     
           write(64,334) hjd(i), ress(i), fout(i), gew(i), fit, var(i)
 334       format(f13.7,1x,f15.5,1x,f10.5,1x,f10.5,1x,f14.4,1x,f14.4)

           if (ress(i).gt.maxres) then
               maxres = ress(i)
           endif
           if (ress(i).lt.minres) then
               minres = ress(i)
           endif
           varb(i) = var(i) + fout(i)
           varo(i) = var(i) - fout(i)
           if (varb(i).gt.maxfit) then
               maxfit = varb(i)
           endif
           if (varo(i).lt.minfit) then
               minfit = varo(i)
           endif
      ENDDO

      close(64)
      ndatanacht(nacht) = l


      do j = 1, 2
           read(11,*,end=1001) 
      enddo

      write(6,*)
      read(11,110,end=1001) fracvar
      fracvar = fracvar*100

 110  format(11x,f7.4)

      do j = 1, 5
           read(11,*,end=1001) 
      enddo

      DO i = 1, 100
           read(11,109,end=1001) cfit(i), (cphase(k),k=1,nfreq)
           cplotphase(i) = cphase(bigamp)
           if (cfit(i).gt.maxfit) then
               maxfit = cfit(i)
           endif
           if (cfit(i).lt.minfit) then
               minfit = cfit(i)
           endif
      ENDDO           
      cplotphase(101) = 1.0
      cfit(101)       = cfit(1)


 109  format(1x,f13.7,15f13.5)
           
 1001 close(11)

      do j = 1 , nfreq
           write(6,*) charfreq(j)
      enddo
      write(6,*)

 7924 write(6,*) 'Which kind of data-set?'
      write(6,*) '0 = equivalent width        6 = Geneva U'
      write(6,*) '1 = 1st normalised moment   7 = Geneva B1'
      write(6,*) '2 = 2nd normalised moment   8 = Geneva B'
      write(6,*) '3 = 3rd normalised moment   9 = Geneva B2'
      write(6,*) '4 = radial velocity         10= Geneva V1'
      write(6,*) '5 = hipparcos Hp            11= Geneva V'
      write(6,*) '                            12= Geneva G'
       read(5,*)  mom
      write(6,*)
      if ((mom.ne.0).and.(mom.ne.0).and.(mom.ne.1).and.(mom.ne.2).and.
     v    (mom.ne.3).and.(mom.ne.4).and.(mom.ne.5).and.(mom.ne.6).and.
     v    (mom.ne.7).and.(mom.ne.8).and.(mom.ne.9).and.(mom.ne.10).and.
     v    (mom.ne.11).and.(mom.ne.12)) goto 7924

      japs = 0

      verschildata = maxfit - minfit
      verschilres  = maxres - minres

      do j = 1, nacht
           do i = 1, 101
                cnachtfit(j,i) = cfit(i) + ((j-1)*verschildata)
           enddo
           do i = 1, ndatanacht(j)
                nachtvar(j,i) = nachtvar(j,i) + ((j-1)*verschildata)
           enddo
      enddo

      maxfi = maxfit
      minfi = minfit
      maxre = maxres
      minre = minres

      if (mom.le.4) then
         maxfit = maxfi + (2*(verschildata/7))
         minfit = minfi - (1.5*(verschildata/7))
         maxres = maxre + (verschilres/8)
         minres = minre - (verschilres/8)
      else
         minfit = maxfi + (1.5*(verschildata/7))
         maxfit = minfi - (2*(verschildata/7))
         minres = maxre + (verschilres/8)
         maxres = minre - (verschilres/8)
      endif

      do j = 1, 101
           lijn(j)   = 0.0
      enddo

      maxnacht = maxfit + ((nacht-1)*verschildata) - (verschildata/7)
      minnacht = minfit

      call plotter

 5298 write(6,*)
      write(6,*) 'Do you want a ps-file? (1=yes; 0=no)'
      read(5,*) japs
      if ((japs.ne.0).and.(japs.ne.1)) goto 5298
  
      if (japs.eq.1) then
           if (plot.eq.1) then
              write(6,*)
              write(6,*) psnaam10
              write(6,*)
           else
              write(6,*)
              write(6,*) psnaam1
              write(6,*)
           endif
           call plotter
           write(6,*)
      endif

      END

c-------------------------------------------------------------------------------
      subroutine plotter

      parameter (MAXOBS=75000)
      parameter (MAXF=11)
      parameter (maxdatanacht=30000)
      parameter (maxnachten=50)
      integer   nacht, ndatanacht(maxdatanacht)
      integer   j , ndata, plot, japs, mom
      real      var(MAXOBS), res(MAXOBS)
      real      cfit(101), schuif, lijn(101)
      real      varb(MAXOBS), varo(MAXOBS)
      real      maxfit, minfit, maxres, minres
      real      plotphase(MAXOBS), cplotphase(101)
      real      maxnacht, minnacht
      real      plotnachtphase(maxnachten,maxdatanacht)
      real      nachtvar(maxnachten,maxdatanacht)
      real      cnachtfit(maxnachten,101)
      real*8    fracvar
      character psnaam1*20,psnaam10*21, cfracvar*5, charfreq(MAXF)*24
      character schrijffile*70,infile*70

      COMMON/lijn1/minfit,maxfit,ndata,japs,plot,mom,psnaam1,psnaam10
      COMMON/lijn2/plotphase,var,varo,varb,charfreq,cplotphase,cfit
      COMMON/lijn3/fracvar,minres,maxres,lijn,res,cfracvar
      COMMON/lijn4/schrijffile,infile
      COMMON/lijn5/minnacht,maxnacht,ndatanacht
      COMMON/lijn6/cnachtfit,plotnachtphase,nachtvar,nacht

      if (japs.eq.0) then
           call pgbegin(0,'?',1,1)
      else
           if (plot.eq.1) call pgbeg(0,psnaam10//'/ps',1,1)
           if (plot.eq.0) call pgbeg(0,psnaam1//'/ps',1,1)
      endif        

      call pgsvp(0.10,0.90,0.30,0.90)
      call pgsci(1)
      call pgswin(0.0,1.0,minfit,maxfit)
      call pgbox('bcts',0.1,2,'bcntsv',0.0,2)
      call pgpt(ndata,plotphase,var,0751)
      do j = 1, ndata
           call pgerry(1,plotphase(j),varo(j),varb(j),1.0)
      enddo

      call pgsch(0.8)
      schuif = 0.02
      DO j = 1 , 3
           call pgmtxt('t',-1.5,schuif,0.0,charfreq(j))
           schuif = schuif + 0.32
      ENDDO
      schuif = 0.02
      DO j = 4 , 6
           call pgmtxt('t',-3.0,schuif,0.0,charfreq(j))
           schuif = schuif + 0.32
      ENDDO
      schuif = 0.02
      DO j = 7 , 9
           call pgmtxt('t',-4.5,schuif,0.0,charfreq(j))
           schuif = schuif + 0.32
      ENDDO
      schuif = 0.02
      DO j = 10 , 11
           call pgmtxt('t',-6.0,schuif,0.0,charfreq(j))
           schuif = schuif + 0.32
      ENDDO
      call pgsch(1.0)

      if (plot.eq.1) then
           call pglabel(' ',' ',psnaam10)
      else
           call pglabel(' ',' ',psnaam1)
      endif
      call pgsch(1.0)
      if (mom.eq.0) call pgmtxt('l',4.0,0.5,0.5,'EW')
      if (mom.eq.1) call pgmtxt('l',4.0,0.5,0.5,'<v> (km/s)')
      if (mom.eq.2) call pgmtxt('l',4.0,0.5,0.5,'<v\\u2\\d> '//
     v     '(km/s)\\u2\\d')
      if (mom.eq.3) call pgmtxt('l',4.0,0.5,0.5,'<v\\u3\\d> '//
     v     '(km/s)\\u3\\d')
      if (mom.eq.4) call pgmtxt('l',4.0,0.5,0.5,'v\\drad\\u '//
     v     '(km/s)')
      if (mom.eq.5) call pgmtxt('l',4.0,0.5,0.5,'Hipparcos H\\dp\\u'//
     v     '(mag)')
      if (mom.eq.6) call pgmtxt('l',4.0,0.5,0.5,'Geneva U '//
     v     '(mag)')
      if (mom.eq.7) call pgmtxt('l',4.0,0.5,0.5,'Geneva B\\d1\\u '//
     v     '(mag)')
      if (mom.eq.8) call pgmtxt('l',4.0,0.5,0.5,'Geneva B '//
     v     '(mag)')
      if (mom.eq.9) call pgmtxt('l',4.0,0.5,0.5,'Geneva B\\d2\\u '//
     v     '(mag)')
      if (mom.eq.10) call pgmtxt('l',4.0,0.5,0.5,'Geneva V\\d1\\u '//
     v     '(mag)')
      if (mom.eq.11) call pgmtxt('l',4.0,0.5,0.5,'Geneva V '//
     v     '(mag)')
      if (mom.eq.12) call pgmtxt('l',4.0,0.5,0.5,'Geneva G '//
     v     '(mag)')
      call pgline(101,cplotphase,cfit)
      write(cfracvar,'(f5.2)') fracvar
      call pgmtxt('b',-1.25,0.50,0.5,'variance reduction = '//
     v     cfracvar//' %')

      call pgsvp(0.10,0.90,0.10,0.30)
      call pgsci(1)
      call pgswin(0.0,1.0,minres,maxres)
      call pgbox('bcnts',0.1,2,'bcntsv',0.0,0)
      call pgpt(ndata,plotphase,res,0751)
      call pgmtxt('l',4.0,0.5,0.5,'residuals')
      call pgmtxt('b',2.5,0.5,0.5,'phase')
      call pgline(101,cplotphase,lijn)

      call pgend

      return

      end

